(****************************************************************************)
(*                         VIESOFORAI                                 *)
(*                     IOI'99, Antalija, Turkija                       *)
(*                Programos autorius: Jurgis Paukonis                 *)
(****************************************************************************)

program grafas;
type masyvas = array [1..300] of byte;

  var f: text;
      n, m, ra, rb, a, b, i, c, lk, ck: integer; { ra, rb - pradin ir galutin virsns }
      sn : array [1..300] of record     { informacija apie viesofor mirksjim virsnse }
                                 c: boolean;  { pradin spalva }
                                 r: integer;  { kiek ji dar degs }
                                 t: array [boolean] of integer; { kiekvienos spalvos degimo laikas }
                             end;

      kl: array [1..300] of ^masyvas;  { kl[a]^[b] - kelio i a  b ilgis,
                                            0 jei kelio nra }

      ch: char;
      q: array [1..300] of integer;     { eil }
      inq: array [1..300] of boolean;   { ar eilje }
      l, p: array [1..300] of integer;    { l[a] - trumpiausio kelio  a ilgis }
                                             { p[a] - i kur ateita  virsn a }
      h, t: integer;                      { eils galva ir uodega }
      rez: array [1..300] of integer;   { trumpiausias kelias (rezultatas) }


function kox (a, st: integer; var lk: integer): boolean;
    { kox - kokia spalva dega virnje a laiku st,
            lk - kiek dar degs i spalva }

 var rez: boolean;
begin
  if st < sn[a].r then begin kox := sn[a].c; lk := sn[a].r-st end
  else begin
         rez := not sn[a].c;
         st := st - sn[a].r;
         st := st mod (sn[a].t[true]+sn[a].t[false]);
         if (st >= sn[a].t[rez]) then begin st := st - sn[a].t[rez]; rez := not rez; end;
         lk := sn[a].t[rez]-st;
         kox := rez;
       end;
end;


function kada (a, b, st: integer): integer;
   { kada - po kiek laiko nuo st virnse a ir b degs vienoda spalva,
           kada = maxint, jei to niekad nebus }

  var c1, c2: boolean;
      l1, l2: integer;
      rez: integer;
begin
  rez := 0;
  c1 := kox (a,st, l1); c2 := kox(b,st,l2);
  if c1 = c2 then kada := 0
    else if l1 <> l2 then
             begin
               if l1 < l2 then kada := l1
                          else kada := l2
             end
             else begin
                    rez := l1;
                    st := st+l1;
                    c1 := kox(a,st,l1); c2 := kox(b,st,l2);
                    if l1 <> l2 then
                      begin
                        if l1 < l2 then kada := rez+l1
                                   else kada := rez+l2
                      end
                      else begin
                             rez := rez + l1;
                             st := st+l1;
                             c1 := kox(a,st,l1); c2 := kox(b,st,l2);
                             if l1 <> l2 then
                               begin
                                 if l1 < l2 then kada := rez+l1
                                            else kada := rez+l2
                               end
                               else kada := maxint;
                           end;
                  end;
end;


begin
  for c := 1 to 300 do
    begin
      getmem (kl[c], sizeof (masyvas));
      fillchar (kl[c]^, sizeof (masyvas), 0);
    end;

  assign (f, 'lights.inp'); reset (f);  {  pradini duomen skaitymas }
  readln (f, ra, rb);
  readln (f, n, m);
  for c := 1 to n do
    begin
      readln (f, ch, sn[c].r, sn[c].t[true], sn[c].t[false]);
      sn[c].c := ch = 'B'
    end;
  for c := 1 to m do
    begin
      readln (f, a, b, i);
      kl[a]^[b] := i;
      kl[b]^[a] := i;
    end;
  close (f);

  for c := 1 to n do l[c] := maxint;
  fillchar (inq, sizeof (inq), false);
  h := 2; t := 1;
  q[1] := ra; l[ra] := 0; inq[ra] := true;
  p[ra] := 0;

  while h <> t do       { kol dar eilj kakas yra ... }
  begin
    for c := 1 to n do
    begin
      i := kl[q[t]]^[c];
      if i <> 0 then   { jei yra kelias  virn c ... }
      begin
        lk := kada(q[t],c,l[q[t]]);  { kiek reiks laukti, kol usidegs vienoda viesa }
        if (lk < maxint) and (l[q[t]]+lk+i < l[c]) then  { jei naujas surastas kelias trumpesnis ... }
          begin
            l[c] := l[q[t]]+lk+i;
            p[c] := q[t];
            if not inq[c] then    { jei dar nra, raome  eil }
              begin
                inq[c] := true;
                q[h] := c;
                h := h mod 300 + 1;
              end;
          end;
      end;
    end;
    inq[q[t]] := false;
    t := t mod 300 + 1;
  end;

  assign (f, 'lights.out'); rewrite (f);
  if l[b] = maxint then writeln (f, 0)
     else begin
            writeln (f, l[rb]);
            ck := 0;
            c := rb;
            while c <> 0 do  { atsekame kelia }
            begin
              inc (ck);
              rez[ck] := c;
              c := p[c];
            end;
            for c := ck downto 2 do write (f, rez[c], ' ');
            writeln (f, rez[1]);
          end;
  close (f);

  for c := 1 to 300 do freemem (kl[c], sizeof (masyvas));
end.